# Class AbstractAnnotationValueVisitor6<R,P>

java.lang.Object
javax.lang.model.util.AbstractAnnotationValueVisitor6<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods
  `P` - the type of the additional parameter to this visitor's methods.

All Implemented Interfaces:
  `AnnotationValueVisitor<R,P>`

Direct Known Subclasses:
  `AbstractAnnotationValueVisitor7, SimpleAnnotationValueVisitor6`

@SupportedSourceVersion(RELEASE_6) public abstract class AbstractAnnotationValueVisitor6<R,P> extends Object implements AnnotationValueVisitor<R,P>
A skeletal visitor for annotation values with default behavior appropriate for the `RELEASE_6` source version.

API Note:

  WARNING: The `AnnotationValueVisitor` interface implemented by this class may have methods added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes and subclasses which extend this class should not declare any instance methods with names beginning with `"visit"`.

  When such a new visit method is added, the default implementation in this class will be to directly or indirectly call the `visitUnknown` method. A new abstract annotation value visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When a new visitor is introduced, portions of this visitor class may be deprecated, including its constructors.

Since:
  1.6
See Also:
  - `AbstractAnnotationValueVisitor7`
  - `AbstractAnnotationValueVisitor8`
  - `AbstractAnnotationValueVisitor9`
  - `AbstractAnnotationValueVisitor14`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`AbstractAnnotationValueVisitor6()`
Deprecated.
Release 6 is obsolete; update to a visitor for a newer release level.

## Method Summary

Modifier and Type
Method
Description
`final R`
`visit(AnnotationValue av)`
Visits an annotation value as if by passing itself to that value's `accept` method passing `null` for the additional parameter.
`final R`
`visit(AnnotationValue av, P p)`
Visits any annotation value as if by passing itself to that value's `accept`.
`R`
`visitUnknown(AnnotationValue av, P p)`
Visits an unknown kind of annotation value.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

### Methods declared in interface AnnotationValueVisitor

`visitAnnotation, visitArray, visitBoolean, visitByte, visitChar, visitDouble, visitEnumConstant, visitFloat, visitInt, visitLong, visitShort, visitString, visitType`
Modifier and Type
Method
Description
`R`
`visitAnnotation(AnnotationMirror a, P p)`
Visits an annotation value in an annotation.
`R`
`visitArray(List<? extends AnnotationValue> vals, P p)`
Visits an array value in an annotation.
`R`
`visitBoolean(boolean b, P p)`
Visits a `boolean` value in an annotation.
`R`
`visitByte(byte b, P p)`
Visits a `byte` value in an annotation.
`R`
`visitChar(char c, P p)`
Visits a `char` value in an annotation.
`R`
`visitDouble(double d, P p)`
Visits a `double` value in an annotation.
`R`
`visitEnumConstant(VariableElement c, P p)`
Visits an `enum` value in an annotation.
`R`
`visitFloat(float f, P p)`
Visits a `float` value in an annotation.
`R`
`visitInt(int i, P p)`
Visits an `int` value in an annotation.
`R`
`visitLong(long i, P p)`
Visits a `long` value in an annotation.
`R`
`visitShort(short s, P p)`
Visits a `short` value in an annotation.
`R`
`visitString(String s, P p)`
Visits a string value in an annotation.
`R`
`visitType(TypeMirror t, P p)`
Visits a type value in an annotation.

## Constructor Details

### AbstractAnnotationValueVisitor6

@Deprecated(since="9") protected AbstractAnnotationValueVisitor6()
Deprecated.
Release 6 is obsolete; update to a visitor for a newer release level.
Constructor for concrete subclasses to call.

## Method Details

### visit

public final R visit(AnnotationValue av, P p)
Visits any annotation value as if by passing itself to that value's `accept`. The invocation `v.visit(av, p)` is equivalent to `av.accept(v, p)`.

Specified by:
  `visit` in interface `AnnotationValueVisitor<R,P>`
Parameters:
  `av` - the value to visit
  `p` - a visitor-specified parameter
Returns:
  a visitor-specified result

### visit

public final R visit(AnnotationValue av)
Visits an annotation value as if by passing itself to that value's `accept` method passing `null` for the additional parameter. The invocation `v.visit(av)` is equivalent to `av.accept(v, null)`.

Specified by:
  `visit` in interface `AnnotationValueVisitor<R,P>`
Parameters:
  `av` - the value to visit
Returns:
  a visitor-specified result

### visitUnknown

public R visitUnknown(AnnotationValue av, P p)
Visits an unknown kind of annotation value. This can occur if the language evolves and new kinds of value can be stored in an annotation.

Specified by:
  `visitUnknown` in interface `AnnotationValueVisitor<R,P>`
Implementation Requirements:
  The default implementation of this method in `AbstractAnnotationValueVisitor6` will always throw `new UnknownAnnotationValueException(av, p)`. This behavior is not required of a subclass.
Parameters:
  `av` - the unknown value being visited
  `p` - a visitor-specified parameter
Returns:
  the result of the visit
Throws:
  `UnknownAnnotationValueException` - a visitor implementation may optionally throw this exception